//Bf2 Rank Mod badge powers File
//Contains all the power giving etc checking functions.

#if defined bf2_powers_included
#endinput
#endif
#define bf2_powers_included

public set_speed(id)
{
	if ( !get_pcvar_num(gPcvarBadgesActive) || !get_pcvar_num(gPcvarBadgePowers) ) return;
	if ( !is_user_alive(id) || freezetime ) return;
	
	new Float:speed;
	
	if ( g_imobile[id] )
	{
		speed = 100.0;
	}
	else
	{
		if (get_user_flags(id) & ADMIN_LEVEL_H)
		{
			//VIPs only have 1 speed no matter the weapon
			speed = 227.0;
		}
		else
		{
			new weapon = get_user_weapon(id);
			
			speed = gCSWeaponSpeed[weapon];
			
			if ( gCurrentFOV[id] <= 45 )
			{
				switch(weapon)
				{
					case CSW_SCOUT: speed = 220.0;
					case CSW_SG550, CSW_AWP, CSW_G3SG1: speed = 150.0;
				}
			}
		}
		
		new smglevel = g_PlayerBadges[id][BADGE_SMG];
		if ( smglevel )
		{
			//15 units faster per level.
			speed += (smglevel * 15.0);
		}
	}
	
	if(speed < 100){
		speed=100.0;
	}
	
	if ( speed != fm_get_user_maxspeed(id) )
	{
		fm_set_user_maxspeed(id, speed);
	}
}

public set_invis(id){
	if ( !get_pcvar_num(gPcvarBadgesActive) || !get_pcvar_num(gPcvarBadgePowers) ) return;
	if ( !is_user_alive(id) ) return;
	
	new shotgunlevel = g_PlayerBadges[id][BADGE_SHOTGUN];
	
	if ( shotgunlevel && get_user_weapon(id) == CSW_KNIFE )
	{
		fm_set_rendering(id, kRenderFxNone, 0, 0, 0, kRenderTransTexture, gInvisAlphaValue[shotgunlevel-1]);
		g_invis[id] = true;
	}
	else
	{
		fm_set_rendering(id);
		g_invis[id] = false;
	}
}

public set_gravity(id){
	if ( !get_pcvar_num(gPcvarBadgesActive) || !get_pcvar_num(gPcvarBadgePowers) ) return;
	if ( !is_user_alive(id) ) return;
	
	new ninjalevel = g_PlayerBadges[id][BADGE_NINJA];
	set_user_gravity(id,1.0-0.0625*ninjalevel);
}

public remove_imobile(id){
	g_imobile[id] = false;
	set_speed(id);
}

public give_userweapon(id){
	if ( !get_pcvar_num(gPcvarBadgesActive) || !get_pcvar_num(gPcvarBadgePowers) ) return;
	if ( !is_user_alive(id) ) return;
	
	new bool:givenitem = false;
	
	new assaultlevel = g_PlayerBadges[id][BADGE_ASSAULT];
	if (assaultlevel && get_pcvar_num(gPcvarHP))
	{
		new hp;
		hp = 100 + (assaultlevel*5);
		
		if ( get_user_health(id) < hp )
		{
			fm_set_user_health(id, hp);
			
			if ( pev(id, pev_max_health) < float(hp) )
			{
				set_pev(id, pev_max_health, float(hp));
			}
			
			givenitem = true;
		}
	}
	
	new flashlevel = g_PlayerBadges[id][BADGE_FLASH];
	
	if ( flashlevel && get_pcvar_num(gPcvarFlash) )
	{
		if ( flashlevel % 2 == 0 )
		{
			add_fb(id,1);
		}
		if ( flashlevel % 4 == 0 )
		{
			add_fb(id,1);
		}
		if ( flashlevel % 2 )
		{
			if ( random_num(1, 2) == 1 )
			{
				add_fb(id,1);
			}
		}
		givenitem = true;
	}
	
	new explosionlevel = g_PlayerBadges[id][BADGE_EXPLOSIVES];
	
	if ( explosionlevel && get_pcvar_num(gPcvarHE)  )
	{
		if ( random_num(1, (5-explosionlevel)) == 1 )
		{
			add_he(id,1);
			givenitem = true;
		}
	}
	
	new duchlevel = g_PlayerBadges[id][BADGE_DUCH];
	
	if ( duchlevel && get_pcvar_num(gPcvarSmoke)  )
	{
		if ( random_num(1, (5-duchlevel)) == 1 )
		{
			add_sg(id,1);
			givenitem = true;
		}
	}
	
	new saperlevel = g_PlayerBadges[id][BADGE_SAPER];
	
	if ( saperlevel  )
	{
		if ( random_num(1, (5-saperlevel)) == 1 )
		{
			fm_give_item(id, "item_thighpack");
			givenitem = true;
		}
	}
	
	new sniperlevel = g_PlayerBadges[id][BADGE_SNIPER];
	
	if ( sniperlevel && rundy>1 && get_pcvar_num(gPcvarFreeAwp) )
	{
		if ( random_num(1, (5-sniperlevel)) == 1)
		{
			new weaponName[32];
			new weaponID = get_user_weapon(id);
			
			fm_give_item(id, "weapon_awp");
			
			if ( weaponID )
			{
				get_weaponname(weaponID, weaponName, charsmax(weaponName));
				engclient_cmd(id, weaponName);
			}
			
			givenitem = true;
		}
	}
	
	if(numofbadges[id]==44){
		fm_give_item(id, "vesthelm");
	}
	
	switch (numofbadges[id])
	{
		case 5 .. 9:
		{
			if ( fm_get_user_armor(id) < 25 )
			{
				fm_set_user_armor(id, 25);
				givenitem = true;
			}
		}
		
		case 10 .. 14:
		{
			if ( fm_get_user_armor(id) < 50 )
			{
				fm_set_user_armor(id, 50);
				givenitem = true;
			}
		}
		
		case 15 .. 19:
		{
			if ( fm_get_user_armor(id) < 75 )
			{
				fm_set_user_armor(id, 75);
				givenitem = true;
			}
		}
		
		case 20 .. 24:
		{
			if ( fm_get_user_armor(id) < 100 )
			{
				fm_set_user_armor(id, 100);
				givenitem = true;
			}
		}
		
		case 25.. 29:
		{
			if ( fm_get_user_armor(id) < 130 )
			{
				fm_set_user_armor(id, 130);
				givenitem = true;
			}
		}
		
		case 30.. 34:
		{
			if ( fm_get_user_armor(id) < 160 )
			{
				fm_set_user_armor(id, 160);
				givenitem = true;
			}
		}
		
		case 35.. 39:
		{
			if ( fm_get_user_armor(id) < 200 )
			{
				fm_set_user_armor(id, 200);
				givenitem = true;
			}
		}
		
		case 40.. 44:
		{
			if ( fm_get_user_armor(id) < 250 )
			{
				fm_set_user_armor(id, 250);
				givenitem = true;
			}
		}
	}
	
	if ( givenitem )
		screen_flash(id, 0, 255, 0, 100); //Green screen flash
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1045\\ f0\\ fs16 \n\\ par }
*/
