//Bf2 Rank Mod check File
//Contains all the badge/rank etc checking functions.

#if defined bf2_check_included
#endinput
#endif
#define bf2_check_included

public check_level(id)
{
	if ( gStatsLoaded[id] < 2 ) return;
	
	new stats[8], bodyhits[8], prevrank;
	new ranked = get_user_stats(id, stats, bodyhits);
	
	prevrank = g_PlayerRank[id];
	new newrank, counter;
	
	for (counter = 0; counter < MAX_RANKS; counter++)
	{
		if ( totalkills[id] >= floatround(gRankXP[counter]*get_pcvar_float(gPcvarXpMultiplier)) )
		{
			newrank = counter;
		}
		else break;
	}
	
	g_PlayerRank[id] = newrank;
	
	numofbadges[id] = 0;
	for (counter = 0; counter < MAX_BADGES; counter++)
	{
		numofbadges[id] += g_PlayerBadges[id][counter];
	}
	
	//These ranks depend on badges, what if badges are turned off? what should we do?
	switch(newrank)
	{
		case 7:
			if ( numofbadges[id] >= MAX_BADGES )
				g_PlayerRank[id] = 17;
		case 8:
			if ( numofbadges[id] >= (MAX_BADGES*2) )
				g_PlayerRank[id] = 18;
		case 15:
			if ( numofbadges[id] == (MAX_BADGES*3) )
				g_PlayerRank[id] = 19;
		case 16:
		//If active, Lieutenant General and General require all badges
		if ( get_pcvar_num(gPcvarBadgesActive) && numofbadges[id] != (MAX_BADGES*4) )
			g_PlayerRank[id] = 15; //If badges active and they don't have all badges demote back to Brigadier General
		else if ( ranked == 2 )
			g_PlayerRank[id] = 20; //Promote to General if Number 2 ranked.
		else if ( ranked == 1 )
			g_PlayerRank[id] = 21; //Promote to Marszalek Polski if Number 1 ranked.
	}
	
	if ( newplayer[id] )
	{
		#if defined KOLOROWY_SAY
		ColorChat(id,TEAM_COLOR,"[BF2]^x03 Twoja ranga:^x04 %s^x03 zostala zaladowana",gRankName[g_PlayerRank[id]]);
		#else
		client_print(id, print_chat, "[BF2] Twoja ranga: %s zostala zaladowana", gRankName[g_PlayerRank[id]]);
		#endif
		client_cmd(id, "spk %s", gSoundRank);
		ranking_officer_check(id);
		newplayer[id] = false;
	}
	else if ( is_ranked_higher(g_PlayerRank[id], prevrank) )
	{
		#if defined KOLOROWY_SAY
		ColorChat(id,TEAM_COLOR,"[BF2]^x03 Awanasowales do rangi^x04 %s", gRankName[g_PlayerRank[id]]);
		#else
		client_print(id, print_chat, "[BF2] Awanasowales do rangi %s", gRankName[g_PlayerRank[id]]);
		#endif
		client_cmd(id, "spk %s", gSoundRank);
		ranking_officer_check(id);
	}
	else if ( g_PlayerRank[id] != prevrank && !is_ranked_higher(g_PlayerRank[id], prevrank) )
	{
		#if defined KOLOROWY_SAY
		ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zostales zdegradowany do rangi^x04 %s", gRankName[g_PlayerRank[id]]);
		#else
		client_print(id, print_chat, "[BF2] Zostales zdegradowany do rangi %s", gRankName[g_PlayerRank[id]]);
		#endif
	}
	
	if ( is_ranked_higher(g_PlayerRank[id], highestrankserver) )
	{
		highestrankserver = g_PlayerRank[id];
		new line[100], name[32];
		get_user_name(id, name, charsmax(name));
		line[0] = 0x04;
		#if defined KOLOROWY_SAY
		ColorChat(id,TEAM_COLOR,"%s^x03 ma najwyzsza range na serwerze. Jego ranga to^x04 %s", name, gRankName[highestrankserver]);
		#else
		formatex(line[1], 98, "%s ma najwyzsza range na serwerze. Jego ranga to %s", name, gRankName[highestrankserver]);
		formatex(highestrankservername, charsmax(highestrankservername), name);
		ShowColorMessage(id, MSG_BROADCAST, line);
		#endif
	}
}

public badge_check_loop()
{
	//This gets run at round end, only check alive players since
	//check_badges is run on death.
	new players[32], num;
	get_players(players, num, "ah");
	
	for ( new counter = 0; counter < num; counter++)
	{
		check_badges(players[counter]);
	}
}

public check_badges(id)
{
	if ( !get_pcvar_num(gPcvarBF2Active) || !get_pcvar_num(gPcvarBadgesActive) ) return;
	
	new bool:badgegained;
	new weaponkillsround;
	new weaponhsround;
	new wroundstats[8], wroundbodyhits[8], wstats[8], wbodyhits[8];
	new currentbadge;
	new kills;
	
	new roundkills[8];
	
	wroundstats[0] = 0;
	wroundstats[2] = 0;
	get_user_rstats(id, roundkills, wroundbodyhits);
		
	//knife badge section
	currentbadge=g_PlayerBadges[id][BADGE_KNIFE];
	wroundstats[0]=0;
	wroundstats[2]=0;
	get_user_wrstats(id,CSW_KNIFE,wroundstats,wroundbodyhits);
	
	kills=knifekills[id];
	
	switch (currentbadge)
	{
		case LEVEL_NONE:
		{
			
			if (wroundstats[0]>1)
			{
				g_PlayerBadges[id][BADGE_KNIFE]=LEVEL_BASIC; //Basic Knife Badge
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_KNIFE][LEVEL_BASIC]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_KNIFE][LEVEL_BASIC]);
				#endif
				badgegained=true;
			}
		}
		case LEVEL_BASIC:
		{
			if (kills>49)
			{
				g_PlayerBadges[id][BADGE_KNIFE]=LEVEL_VETERAN; //Veteran Knife Badge
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_KNIFE][LEVEL_VETERAN]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_KNIFE][LEVEL_VETERAN]);
				#endif				
				badgegained=true;
			}
		}
		case LEVEL_VETERAN:
		{
			if ((wroundstats[0]>2) && (wroundstats[2]>0) && (kills>99))
			{
				g_PlayerBadges[id][BADGE_KNIFE]=LEVEL_EXPERT; //Expert Knife Badge
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_KNIFE][LEVEL_EXPERT]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_KNIFE][LEVEL_EXPERT]);
				#endif	
				badgegained=true;
			}
		}
		case LEVEL_EXPERT:
		{
			if ((wroundstats[0]>3) && (wroundstats[2]>1) && (kills>149))
			{
				g_PlayerBadges[id][BADGE_KNIFE]=LEVEL_PROFESIONAL; //Profesjonalista Knife Badge
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_KNIFE][LEVEL_PROFESIONAL]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_KNIFE][LEVEL_PROFESIONAL]);
				#endif	
				badgegained=true;
			}
		}
	}
	//End knife section
	
	//Pistol badge section
	currentbadge=g_PlayerBadges[id][BADGE_PISTOL];
	
	if (currentbadge!=LEVEL_BASIC) //don't bother getting round stats if badge = 1 because no round based checks needed for level 2
	{
		
		weaponkillsround=0;
		weaponhsround=0;
		
		wroundstats[0]=0;
		wroundstats[2]=0;
		get_user_wrstats(id,CSW_DEAGLE,wroundstats,wroundbodyhits);
		weaponkillsround=wroundstats[0];
		weaponhsround=wroundstats[2];
		
		wroundstats[0]=0;
		wroundstats[2]=0;
		get_user_wrstats(id,CSW_ELITE,wroundstats,wroundbodyhits);
		weaponkillsround+=wroundstats[0];
		weaponhsround+=wroundstats[2];
		
		wroundstats[0]=0;
		wroundstats[2]=0;
		get_user_wrstats(id,CSW_P228,wroundstats,wroundbodyhits);
		weaponkillsround+=wroundstats[0];
		weaponhsround+=wroundstats[2];
		
		wroundstats[0]=0;
		wroundstats[2]=0;
		get_user_wrstats(id,CSW_FIVESEVEN,wroundstats,wroundbodyhits);
		weaponkillsround+=wroundstats[0];
		weaponhsround+=wroundstats[2];
		
		wroundstats[0]=0;
		wroundstats[2]=0;
		get_user_wrstats(id,CSW_USP,wroundstats,wroundbodyhits);
		weaponkillsround+=wroundstats[0];
		weaponhsround+=wroundstats[2];
		
		wroundstats[0]=0;
		wroundstats[2]=0;
		get_user_wrstats(id,CSW_GLOCK18,wroundstats,wroundbodyhits);
		weaponkillsround+=wroundstats[0];
		weaponhsround+=wroundstats[2];
	}
	
	kills=pistolkills[id];
	
	switch (currentbadge)
	{
		case LEVEL_NONE:
		{
			
			if (weaponkillsround>2)
			{
				g_PlayerBadges[id][BADGE_PISTOL]=LEVEL_BASIC; //Basic Pistol Badge
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_PISTOL][LEVEL_BASIC]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_PISTOL][LEVEL_BASIC]);
				#endif
				badgegained=true;
			}
		}
		case LEVEL_BASIC:
		{
			if (kills>99)
			{
				g_PlayerBadges[id][BADGE_PISTOL]=LEVEL_VETERAN; //Veteran Pistol Badge
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_PISTOL][LEVEL_VETERAN]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_PISTOL][LEVEL_VETERAN]);
				#endif
				badgegained=true;
			}
		}
		case LEVEL_VETERAN:
		{
			if ((weaponkillsround>2) && (weaponhsround>0) && (kills>199))
			{
				g_PlayerBadges[id][BADGE_PISTOL]=LEVEL_EXPERT; //Expert Pistol Badge
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_PISTOL][LEVEL_EXPERT]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_PISTOL][LEVEL_EXPERT]);
				#endif
				badgegained=true;
			}
		}
		case LEVEL_EXPERT:
		{
			if ((weaponkillsround>3) && (weaponhsround>1) && (kills>299))
			{
				g_PlayerBadges[id][BADGE_PISTOL]=LEVEL_PROFESIONAL; //Profesjonalista Pistol Badge
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_PISTOL][LEVEL_PROFESIONAL]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_PISTOL][LEVEL_PROFESIONAL]);
				#endif
				badgegained=true;
			}
		}
	}
	//End Pistol section
	
	
	//Assault badge section
	currentbadge=g_PlayerBadges[id][BADGE_ASSAULT];
	wstats[0]=0;
	wstats[4]=0;
	wstats[5]=0;
	wroundstats[0]=0;
	
	get_user_stats(id,wstats,wbodyhits);
	
	new acc = floatround((float(wstats[5])/float(wstats[4]))*100);
	accuracy[id]=acc;
	roundkills[0]+=Rheadsplashes[id];
	
	switch (currentbadge)
	{
		case LEVEL_NONE:
		{
			if (roundkills[0]>2)
			{
				g_PlayerBadges[id][BADGE_ASSAULT]=LEVEL_BASIC; //Basic Assault Badge
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_ASSAULT][LEVEL_BASIC]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_ASSAULT][LEVEL_BASIC]);
				#endif
				badgegained=true;
			}
		}
		case LEVEL_BASIC:
		{
			if ((roundkills[0]>2) && (roundkills[2]>0) && (totalkills[id]>999))
			{
				g_PlayerBadges[id][BADGE_ASSAULT]=LEVEL_VETERAN; //Veteran Assault Badge
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_ASSAULT][LEVEL_VETERAN]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_ASSAULT][LEVEL_VETERAN]);
				#endif
				badgegained=true;
			}
		}
		case LEVEL_VETERAN:
		{
			if ((roundkills[0]>3) && (roundkills[2]>1) && (totalkills[id]>1999))
			{
				g_PlayerBadges[id][BADGE_ASSAULT]=LEVEL_EXPERT; //Expert Assault Badge
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_ASSAULT][LEVEL_VETERAN]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_ASSAULT][LEVEL_VETERAN]);
				#endif
				badgegained=true;
			}
		}
		case LEVEL_EXPERT:
		{
			if ((roundkills[0]>4) && (roundkills[2]>2) && (totalkills[id]>2999))
			{
				g_PlayerBadges[id][BADGE_ASSAULT]=LEVEL_PROFESIONAL; //Profesjonalista Assault Badge
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_ASSAULT][LEVEL_PROFESIONAL]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_ASSAULT][LEVEL_PROFESIONAL]);
				#endif
				badgegained=true;
			}
		}
	}
	//End Assault section
	
	
	//Sniper badge section
	currentbadge=g_PlayerBadges[id][BADGE_SNIPER];
	
	
	if (currentbadge!=LEVEL_BASIC) //don't bother getting round stats if badge = 1 because no round based checks needed for level 2
	{
		weaponkillsround=0;
		weaponhsround=0;
		
		wroundstats[0]=0;
		wroundstats[2]=0;
		get_user_wrstats(id,CSW_AWP,wroundstats,wroundbodyhits);
		weaponkillsround=wroundstats[0];
		weaponhsround=wroundstats[2];
		
		wroundstats[0]=0;
		wroundstats[2]=0;
		get_user_wrstats(id,CSW_SCOUT,wroundstats,wroundbodyhits);
		weaponkillsround+=wroundstats[0];
		weaponhsround+=wroundstats[2];
		
		wroundstats[0]=0;
		wroundstats[2]=0;
		get_user_wrstats(id,CSW_G3SG1,wroundstats,wroundbodyhits);
		weaponkillsround+=wroundstats[0];
		weaponhsround+=wroundstats[2];
		
		wroundstats[0]=0;
		wroundstats[2]=0;
		get_user_wrstats(id,CSW_SG550,wroundstats,wroundbodyhits);
		weaponkillsround+=wroundstats[0];
		weaponhsround+=wroundstats[2];
	}
	
	kills=sniperkills[id];
	
	switch (currentbadge)
	{
		case LEVEL_NONE:
		{
			if (weaponkillsround>2)
			{
				g_PlayerBadges[id][BADGE_SNIPER]=LEVEL_BASIC; //Basic Sniper Badge
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_SNIPER][LEVEL_BASIC]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_SNIPER][LEVEL_BASIC]);
				#endif
				badgegained=true;
			}
		}
		case LEVEL_BASIC:
		{
			if (kills>99)
			{
				g_PlayerBadges[id][BADGE_SNIPER]=LEVEL_VETERAN; //Veteran Sniper Badge
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_SNIPER][LEVEL_VETERAN]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_SNIPER][LEVEL_VETERAN]);
				#endif
				badgegained=true;
			}
		}
		case LEVEL_VETERAN:
		{
			if ((weaponkillsround>2) && (weaponhsround>0) && (kills>199))
			{
				g_PlayerBadges[id][BADGE_SNIPER]=LEVEL_EXPERT; //Expert Sniper Badge
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_SNIPER][LEVEL_EXPERT]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_SNIPER][LEVEL_EXPERT]);
				#endif
				badgegained=true;
			}
		}
		case LEVEL_EXPERT:
		{
			if ((weaponkillsround>3) && (weaponhsround>1) && (kills>299))
			{
				g_PlayerBadges[id][BADGE_SNIPER]=LEVEL_PROFESIONAL; //Profesjonalista Sniper Badge
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_SNIPER][LEVEL_PROFESIONAL]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_SNIPER][LEVEL_PROFESIONAL]);
				#endif
				badgegained=true;
			}
		}
	}
	//End Sniper section
	
	//Support badge section
	currentbadge=g_PlayerBadges[id][BADGE_SUPPORT];
	wroundstats[0]=0;
	wroundstats[2]=0;
	get_user_wrstats(id,CSW_M249,wroundstats,wroundbodyhits);
	
	kills=parakills[id];
	
	switch (currentbadge)
	{
		case LEVEL_NONE:
		{
			if (wroundstats[0]>=2)
			{
				g_PlayerBadges[id][BADGE_SUPPORT]=LEVEL_BASIC; //Basic Support Badge
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_SUPPORT][LEVEL_BASIC]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_SUPPORT][LEVEL_BASIC]);
				#endif
				badgegained=true;
			}
		}
		case LEVEL_BASIC:
		{
			if (kills>=100)
			{
				g_PlayerBadges[id][BADGE_SUPPORT]=LEVEL_VETERAN; //Veteran Support Badge
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_SUPPORT][LEVEL_VETERAN]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_SUPPORT][LEVEL_VETERAN]);
				#endif
				badgegained=true;
			}
		}
		case LEVEL_VETERAN:
		{
			if ((wroundstats[0]>=3) && (wroundstats[2]>=1) && (kills>=200))
			{
				g_PlayerBadges[id][BADGE_SUPPORT]=LEVEL_EXPERT; //Expert Support Badge
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_SUPPORT][LEVEL_EXPERT]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_SUPPORT][LEVEL_EXPERT]);
				#endif
				badgegained=true;
			}
		}
		case LEVEL_EXPERT:
		{
			if ((wroundstats[0]>=4) && (wroundstats[2]>=2) && (kills>=300))
			{
				g_PlayerBadges[id][BADGE_SUPPORT]=LEVEL_PROFESIONAL; //Profesjonalista Support Badge
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_SUPPORT][LEVEL_PROFESIONAL]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_SUPPORT][LEVEL_PROFESIONAL]);
				#endif
				badgegained=true;
			}
		}
	}
	//End support section
	
	//Explosives badge section
	currentbadge=g_PlayerBadges[id][BADGE_EXPLOSIVES];
	
	switch (currentbadge)
	{
		case LEVEL_NONE:
		{
			if (grenadekills[id]>24)
			{
				g_PlayerBadges[id][BADGE_EXPLOSIVES]=LEVEL_BASIC; //Basic Explosives Badge
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_EXPLOSIVES][LEVEL_BASIC]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_EXPLOSIVES][LEVEL_BASIC]);
				#endif
				badgegained=true;
			}
		}
		case LEVEL_BASIC:
		{
			if (grenadekills[id]>49)
			{
				g_PlayerBadges[id][BADGE_EXPLOSIVES]=LEVEL_VETERAN; //Veteran Explosives Badge
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_EXPLOSIVES][LEVEL_VETERAN]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_EXPLOSIVES][LEVEL_VETERAN]);
				#endif
				badgegained=true;
			}
		}
		case LEVEL_VETERAN:
		{
			if (grenadekills[id]>99)
			{
				g_PlayerBadges[id][BADGE_EXPLOSIVES]=LEVEL_EXPERT; //Expert Explosives Badge
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_EXPLOSIVES][LEVEL_EXPERT]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_EXPLOSIVES][LEVEL_EXPERT]);
				#endif
				badgegained=true;
			}
		}
		case LEVEL_EXPERT:
		{
			if (grenadekills[id]>199)
			{
				g_PlayerBadges[id][BADGE_EXPLOSIVES]=LEVEL_PROFESIONAL; //Profesjonalista Explosives Badge
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_EXPLOSIVES][LEVEL_PROFESIONAL]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_EXPLOSIVES][LEVEL_PROFESIONAL]);
				#endif
				badgegained=true;
			}
		}
	}
	//End Explosives section
	
	//Shotgun badge section
	currentbadge=g_PlayerBadges[id][BADGE_SHOTGUN];
	
	
	if (currentbadge!=LEVEL_BASIC) //don't bother getting round stats if badge = 1 because no round based checks needed for level 2
	{
		weaponkillsround=0;
		weaponhsround=0;
		
		wroundstats[0]=0;
		wroundstats[2]=0;
		get_user_wrstats(id,CSW_XM1014,wroundstats,wroundbodyhits);
		weaponkillsround=wroundstats[0];
		weaponhsround=wroundstats[2];
		
		wroundstats[0]=0;
		wroundstats[2]=0;
		get_user_wrstats(id,CSW_M3,wroundstats,wroundbodyhits);
		weaponkillsround+=wroundstats[0];
		weaponhsround+=wroundstats[2];
	}
	
	kills=shotgunkills[id];
	
	switch (currentbadge)
	{
		case LEVEL_NONE:
		{
			if (weaponkillsround>2)
			{
				g_PlayerBadges[id][BADGE_SHOTGUN]=LEVEL_BASIC;
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_SHOTGUN][LEVEL_BASIC]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_SHOTGUN][LEVEL_BASIC]);
				#endif
				badgegained=true;
			}
		}
		case LEVEL_BASIC:
		{
			if (kills>99)
			{
				g_PlayerBadges[id][BADGE_SHOTGUN]=LEVEL_VETERAN;
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_SHOTGUN][LEVEL_VETERAN]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_SHOTGUN][LEVEL_VETERAN]);
				#endif
				badgegained=true;
			}
		}
		case LEVEL_VETERAN:
		{
			if ((weaponkillsround>2) && (weaponhsround>0) && (kills>199))
			{
				g_PlayerBadges[id][BADGE_SHOTGUN]=LEVEL_EXPERT;
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_SHOTGUN][LEVEL_EXPERT]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_SHOTGUN][LEVEL_EXPERT]);
				#endif
				badgegained=true;
			}
		}
		case LEVEL_EXPERT:
		{
			if ((weaponkillsround>3) && (weaponhsround>1) && (kills>349))
			{
				g_PlayerBadges[id][BADGE_SHOTGUN]=LEVEL_PROFESIONAL;
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_SHOTGUN][LEVEL_PROFESIONAL]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_SHOTGUN][LEVEL_PROFESIONAL]);
				#endif
				badgegained=true;
			}
		}
	}
	//End Shotgun section
	
	
	//SMG badge section
	currentbadge=g_PlayerBadges[id][BADGE_SMG];
	
	
	if (currentbadge!=LEVEL_BASIC) //don't bother getting round stats if badge = 1 because no round based checks needed for level 2
	{
		weaponkillsround=0;
		weaponhsround=0;
		
		wroundstats[0]=0;
		wroundstats[2]=0;
		get_user_wrstats(id,CSW_MAC10,wroundstats,wroundbodyhits);
		weaponkillsround=wroundstats[0];
		weaponhsround=wroundstats[2];
		
		wroundstats[0]=0;
		wroundstats[2]=0;
		get_user_wrstats(id,CSW_UMP45,wroundstats,wroundbodyhits);
		weaponkillsround+=wroundstats[0];
		weaponhsround+=wroundstats[2];
		
		wroundstats[0]=0;
		wroundstats[2]=0;
		get_user_wrstats(id,CSW_MP5NAVY,wroundstats,wroundbodyhits);
		weaponkillsround+=wroundstats[0];
		weaponhsround+=wroundstats[2];
		
		wroundstats[0]=0;
		wroundstats[2]=0;
		get_user_wrstats(id,CSW_TMP,wroundstats,wroundbodyhits);
		weaponkillsround+=wroundstats[0];
		weaponhsround+=wroundstats[2];
		
		wroundstats[0]=0;
		wroundstats[2]=0;
		get_user_wrstats(id,CSW_P90,wroundstats,wroundbodyhits);
		weaponkillsround+=wroundstats[0];
		weaponhsround+=wroundstats[2];
	}
	
	kills=smgkills[id];
	
	switch (currentbadge)
	{
		case LEVEL_NONE:
		{
			if (weaponkillsround>2)
			{
				g_PlayerBadges[id][BADGE_SMG]=LEVEL_BASIC;
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_SMG][LEVEL_BASIC]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_SMG][LEVEL_BASIC]);
				#endif
				badgegained=true;
			}
		}
		case LEVEL_BASIC:
		{
			if (kills>99)
			{
				g_PlayerBadges[id][BADGE_SMG]=LEVEL_VETERAN;
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_SMG][LEVEL_VETERAN]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_SMG][LEVEL_VETERAN]);
				#endif
				badgegained=true;
			}
		}
		case LEVEL_VETERAN:
		{
			if ((weaponkillsround>2) && (weaponhsround>0) && (kills>199))
			{
				g_PlayerBadges[id][BADGE_SMG]=LEVEL_EXPERT;
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_SMG][LEVEL_EXPERT]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_SMG][LEVEL_EXPERT]);
				#endif
				badgegained=true;
			}
		}
		case LEVEL_EXPERT:
		{
			if ((weaponkillsround>3) && (weaponhsround>1) && (kills>349))
			{
				g_PlayerBadges[id][BADGE_SMG]=LEVEL_PROFESIONAL;
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_SMG][LEVEL_PROFESIONAL]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_SMG][LEVEL_PROFESIONAL]);
				#endif
				badgegained=true;
			}
		}
	}
	//End SMG section
	
	//Flash badge section
	currentbadge=g_PlayerBadges[id][BADGE_FLASH];
	
	switch (currentbadge)
	{
		case LEVEL_NONE:
		{
			if (flashbangs[id]>49)
			{
				g_PlayerBadges[id][BADGE_FLASH]=LEVEL_BASIC; //Basic Flash Badge
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_FLASH][LEVEL_BASIC]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_FLASH][LEVEL_BASIC]);
				#endif
				badgegained=true;
			}
		}
		case LEVEL_BASIC:
		{
			if (flashbangs[id]>99)
			{
				g_PlayerBadges[id][BADGE_FLASH]=LEVEL_VETERAN; //Veteran Flash Badge
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_FLASH][LEVEL_VETERAN]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_FLASH][LEVEL_VETERAN]);
				#endif
				badgegained=true;
			}
		}
		case LEVEL_VETERAN:
		{
			if (flashbangs[id]>199)
			{
				g_PlayerBadges[id][BADGE_FLASH]=LEVEL_EXPERT; //Expert Flash Badge
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_FLASH][LEVEL_EXPERT]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_FLASH][LEVEL_EXPERT]);
				#endif
				badgegained=true;
			}
		}
		case LEVEL_EXPERT:
		{
			if (flashbangs[id]>399)
			{
				g_PlayerBadges[id][BADGE_FLASH]=LEVEL_PROFESIONAL; //Profesjonalista Flash Badge
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_FLASH][LEVEL_PROFESIONAL]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_FLASH][LEVEL_PROFESIONAL]);
				#endif
				badgegained=true;
			}
		}
	}
	//End Flash section
	
	//Wybuchy badge section
	currentbadge=g_PlayerBadges[id][BADGE_EXPLOSIONS];
	
	switch (currentbadge)
	{
		case LEVEL_NONE:
		{
			if (explosions[id]>9)
			{
				g_PlayerBadges[id][BADGE_EXPLOSIONS]=LEVEL_BASIC;
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_EXPLOSIONS][LEVEL_BASIC]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_EXPLOSIONS][LEVEL_BASIC]);
				#endif
				badgegained=true;
			}
		}
		case LEVEL_BASIC:
		{
			if (explosions[id]>24)
			{
				g_PlayerBadges[id][BADGE_EXPLOSIONS]=LEVEL_VETERAN;
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_EXPLOSIONS][LEVEL_VETERAN]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_EXPLOSIONS][LEVEL_VETERAN]);
				#endif
				badgegained=true;
			}
		}
		case LEVEL_VETERAN:
		{
			if (explosions[id]>44)
			{
				g_PlayerBadges[id][BADGE_EXPLOSIONS]=LEVEL_EXPERT;
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_EXPLOSIONS][LEVEL_EXPERT]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_EXPLOSIONS][LEVEL_EXPERT]);
				#endif
				badgegained=true;
			}
		}
		case LEVEL_EXPERT:
		{
			if (explosions[id]>74)
			{
				g_PlayerBadges[id][BADGE_EXPLOSIONS]=LEVEL_PROFESIONAL;
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_EXPLOSIONS][LEVEL_PROFESIONAL]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_EXPLOSIONS][LEVEL_PROFESIONAL]);
				#endif
				badgegained=true;
			}
		}
	}
	//End Wybuchy section
	
	//Defuses badge section
	currentbadge=g_PlayerBadges[id][BADGE_SAPER];
	
	switch (currentbadge)
	{
		case LEVEL_NONE:
		{
			if (defuses[id]>9)
			{
				g_PlayerBadges[id][BADGE_SAPER]=LEVEL_BASIC; //Basic Defuse Badge
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_SAPER][LEVEL_BASIC]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_SAPER][LEVEL_BASIC]);
				#endif
				badgegained=true;
			}
		}
		case LEVEL_BASIC:
		{
			if (defuses[id]>24)
			{
				g_PlayerBadges[id][BADGE_SAPER]=LEVEL_VETERAN; //Veteran Defuse Badge
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_SAPER][LEVEL_VETERAN]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_SAPER][LEVEL_VETERAN]);
				#endif
				badgegained=true;
			}
		}
		case LEVEL_VETERAN:
		{
			if (defuses[id]>44)
			{
				g_PlayerBadges[id][BADGE_SAPER]=LEVEL_EXPERT; //Expert Defuse Badge
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_SAPER][LEVEL_EXPERT]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_SAPER][LEVEL_EXPERT]);
				#endif
				badgegained=true;
			}
		}
		case LEVEL_EXPERT:
		{
			if (defuses[id]>74)
			{
				g_PlayerBadges[id][BADGE_SAPER]=LEVEL_PROFESIONAL; //Profesjonalista Defuse Badge
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_SAPER][LEVEL_PROFESIONAL]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_SAPER][LEVEL_PROFESIONAL]);
				#endif
				badgegained=true;
			}
		}
	}
	//End Defuses section
	
	//Ninja badge section
	currentbadge=g_PlayerBadges[id][BADGE_NINJA];
	
	switch (currentbadge)
	{
		case LEVEL_NONE:
		{
			if (headsplashes[id]>=10)
			{
				g_PlayerBadges[id][BADGE_NINJA]=LEVEL_BASIC; //Basic Ninja Badge
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_NINJA][LEVEL_BASIC]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_NINJA][LEVEL_BASIC]);
				#endif
				badgegained=true;
			}
		}
		case LEVEL_BASIC:
		{
			if (headsplashes[id]>=25 && roundkills[0]>=2 && Rheadsplashes[id]>=1)
			{
				g_PlayerBadges[id][BADGE_NINJA]=LEVEL_VETERAN; //Veteran Ninja Badge
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_NINJA][LEVEL_VETERAN]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_NINJA][LEVEL_VETERAN]);
				#endif
				badgegained=true;
			}
		}
		case LEVEL_VETERAN:
		{
			if (headsplashes[id]>=45 && roundkills[0]>=3 && Rheadsplashes[id]>=1)
			{
				g_PlayerBadges[id][BADGE_NINJA]=LEVEL_EXPERT; //Expert Ninja Badge
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_NINJA][LEVEL_EXPERT]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_NINJA][LEVEL_EXPERT]);
				#endif
				badgegained=true;
			}
		}
		case LEVEL_EXPERT:
		{
			if (headsplashes[id]>=75 && roundkills[0]>=4 && Rheadsplashes[id]>=2)
			{
				g_PlayerBadges[id][BADGE_NINJA]=LEVEL_PROFESIONAL; //Profesjonalista Ninja Badge
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_NINJA][LEVEL_PROFESIONAL]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_NINJA][LEVEL_PROFESIONAL]);
				#endif
				badgegained=true;
			}
		}
	}
	//End Ninja section
	
	//Duch badge section
	currentbadge=g_PlayerBadges[id][BADGE_DUCH];
	
	switch (currentbadge)
	{
		case LEVEL_NONE:
		{
			if (zabiciaWdymie[id]>=10)
			{
				g_PlayerBadges[id][BADGE_DUCH]=LEVEL_BASIC; //Basic Duch Badge
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_DUCH][LEVEL_BASIC]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_DUCH][LEVEL_BASIC]);
				#endif
				badgegained=true;
			}
		}
		case LEVEL_BASIC:
		{
			if (zabiciaWdymie[id]>=20 && zabiciaWdymieHS[id]>=5)
			{
				g_PlayerBadges[id][BADGE_DUCH]=LEVEL_VETERAN; //Veteran Duch Badge
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_DUCH][LEVEL_VETERAN]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_DUCH][LEVEL_VETERAN]);
				#endif
				badgegained=true;
			}
		}
		case LEVEL_VETERAN:
		{
			if (zabiciaWdymie[id]>=35 && zabiciaWdymieHS[id]>=10 && zabiciaWdymieNozem[id]>=3 && roundkills[0]>=2 && RzabiciaWdymie[id]>=1)
			{
				g_PlayerBadges[id][BADGE_DUCH]=LEVEL_EXPERT; //Expert Duch Badge
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_DUCH][LEVEL_EXPERT]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_DUCH][LEVEL_EXPERT]);
				#endif
				badgegained=true;
			}
		}
		case LEVEL_EXPERT:
		{
			if (zabiciaWdymie[id]>=60 && zabiciaWdymieHS[id]>=20 && zabiciaWdymieNozem[id]>=8 && zabiciaWdymieNozemWglowe[id]>=3 && roundkills[0]>=3 && RzabiciaWdymie[id]>=2)
			{
				g_PlayerBadges[id][BADGE_DUCH]=LEVEL_PROFESIONAL; //Profesjonalista Duch Badge
				#if defined KOLOROWY_SAY
				ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zdobyles odznake:^x04 %s",gBadgeName[BADGE_DUCH][LEVEL_PROFESIONAL]);
				#else
				client_print(id,print_chat,"[BF2] Zdobyles odznake: %s",gBadgeName[BADGE_DUCH][LEVEL_PROFESIONAL]);
				#endif
				badgegained=true;
			}
		}
	}
	//End Duch section
	
	if (badgegained)
	{
		client_cmd(id, "spk %s", gSoundBadge);
		save_badges(id);
	}
}

bool:is_ranked_higher(rank1, rank2)
{
return (gRankOrder[rank1] > gRankOrder[rank2]) ? true : false;
}

public ranking_officer_check(id)
{
if(!is_user_connected(id))return;
new idRank = g_PlayerRank[id];

if ( !is_ranked_higher(idRank, highestrank) ) return;

highestrank = idRank;
highestrankid = id;
new name[32];
get_user_name(id, name, charsmax(name));
new line[100];
line[0] = 0x04;
#if defined KOLOROWY_SAY
ColorChat(0,TEAM_COLOR,"^x04[BF2] ^x01Gracz ^x04%s ^x01jest obecnie Liderem rankingu oficerskiego z ranga ^x04%s", name, gRankName[idRank]);
#else
formatex(line[1], 98, "%s obecnie jest Liderem rankingu oficerskiego z ranga %s", name, gRankName[idRank]);
ShowColorMessage(id, MSG_BROADCAST, line);
#endif
}

public ranking_officer_disconnect()
{
	new players[32], num, player;
	get_players(players, num, "h");

	highestrank = 0;
	highestrankid = 0;

	for (new i = 0; i < num; i++)
	{
		player = players[i];
		if ( is_ranked_higher(g_PlayerRank[player], highestrank) )
		{
			highestrank = g_PlayerRank[player];
			highestrankid = player;
		}
	}

	if ( !highestrank )
		return;
	
	new name[32];
	get_user_name(highestrankid, name, charsmax(name));
	new line[100];
	line[0] = 0x04;
#if defined KOLOROWY_SAY
	ColorChat(0,BLUE,"%s^x03 obecnie jest Liderem rankingu oficerskiego z ranga^x04 %s", name, gRankName[highestrank]);
#else
	formatex(line[1], 98, "%s obecnie jest Liderem rankingu oficerskiego z ranga %s", name, gRankName[highestrank]);
	ShowColorMessage(highestrankid, MSG_BROADCAST, line);
#endif
}

public award_check()
{
	new players[32], num;
	get_players(players, num, "h");
	
	new tempfrags, id;
	
	new swapfrags, swapid;
	
	new starfrags[3]; //0 - Bronze / 1 - Silver / 2 - Gold
	new starid[3];
	
	for (new i = 0; i < num; i++)
	{
		id = players[i];
		tempfrags = get_user_frags(id);
		if ( tempfrags > starfrags[0] )
		{
			starfrags[0] = tempfrags;
			starid[0] = id;
			if ( tempfrags > starfrags[1] )
			{
				swapfrags = starfrags[1];
				swapid = starid[1];
				starfrags[1] = tempfrags;
				starid[1] = id;
				starfrags[0] = swapfrags;
				starid[0] = swapid;
				
				if ( tempfrags > starfrags[2] )
				{
					swapfrags = starfrags[2];
					swapid = starid[2];
					starfrags[2] = tempfrags;
					starid[2] = id;
					starfrags[1] = swapfrags;
					starid[1] = swapid;
				}
			}
		}
		//save_badges(id);
	}
	
	new winner = starid[2];
	new bool:newleader = false;
	
	if ( !winner )
		return;
	
	//We now should have our three awards
	
	bronze[starid[0]]++;
	silver[starid[1]]++;
	gold[winner]++;
	
	new name[32];
	get_user_name(starid[2], name, charsmax(name));
	
	if ( gold[winner] > mostwins )
	{
		mostwins = gold[winner];
		formatex(mostwinsname, charsmax(mostwinsname), name);
	}
	
	//new name0[32];
	//new name1[32];
	//new name2[32];
	//get_user_name(starid[0], name2, charsmax(name2));
	//get_user_name(starid[1], name1, charsmax(name1));
	//get_user_name(starid[2], name0, charsmax(name0));
	
	new iaPlayers[32], iPlayers;
	get_players(iaPlayers, iPlayers);
	//server_save();
	
	new line[100];
	line[0] = 0x04;
	#if defined KOLOROWY_SAY
	ColorChat(0,YELLOW,"Gratulacje dla Zwyciezcow! ^x01[BF2]");
	#else
	formatex(line[1], 98, "[BF2] Gratulacje dla Zwyciezcow!");
	ShowColorMessage(starid[2], MSG_BROADCAST, line);
	#endif
	
	line[0] = 0x04;
	
	get_user_name(starid[0], name, charsmax(name));
	line[0] = 0x04;
	#if defined KOLOROWY_SAY
	ColorChat(0,RED,"%s - Brazowy Medal -^x04 %i^x01 Fragow ^x04[BF2]", name, starfrags[0]);
	#else
	formatex(line[1], 98, "[BF2] %s - Brazowy Medal - %i Zabojstw", name, starfrags[0]);
	ShowColorMessage(starid[2], MSG_BROADCAST, line);
	#endif
	
	get_user_name(starid[1], name, charsmax(name));
	line[0] = 0x04;
	#if defined KOLOROWY_SAY
	ColorChat(0,GREY,"%s - Srebrny Medal -^x04 %i^x01 Fragow ^x04[BF2]", name, starfrags[1]);
	#else
	formatex(line[1], 98, "%s - Srebrny Medal - %i Zabojstw", name, starfrags[1]);
	ShowColorMessage(starid[2], MSG_BROADCAST, line);
	#endif
	
	get_user_name(starid[2], name, charsmax(name));
	
	if(starfrags[2]>mapmaxfrags){
		newleader=true;
		mapmaxfrags=starfrags[2];
		mapmaxfragsname=name;
	}
	
	line[0] = 0x04;
	#if defined KOLOROWY_SAY
	if (newleader){
		ColorChat(0,BLUE,"%s - Platynowy Medal -^x01 %i^x04 Fragow ^x01[BF2] -^x04 NOWY LIDER", name, starfrags[2]);
		platine[winner]++;
	}
	else
		ColorChat(0,GREEN,"%s - Zloty Medal -^x01 %i^x04 Fragow ^x01[BF2]", name, starfrags[2]);
	#else
	if (newleader){
		formatex(line[1], 98, "%s - Platynowy Medal - %i Zabojstw - Nowy Lider", name, starfrags[2]);
		platine[winner]++;
	}
	else
		formatex(line[1], 98, "%s - Zloty Medal - %i Zabojstw", name, starfrags[2]);
	ShowColorMessage(starid[2], MSG_BROADCAST, line);
	#endif
	
	server_save();
	
	//format(str,1023,"<html><frameset rows='100%%,*' frameborder='no' border='0' framespacing='0'><frame src='http://fragotowi.gameclan.pl/bf2/bf2win.php?z0=%s&p0=%d&z1=%s&p1=%d&z2=%s&p2=%d'></frameset></body></html>",name0,starid[0],name1,starid[1],name2,starid[2]);
	//for (iPlayer = 0; iPlayer < iPlayers; ++iPlayer){
	//	show_motd(iaPlayers[iPlayer], str, "Zwyciezcy mapy")
	//}
}

#if defined KOLOROWY_SAY
/*
ShowColorMessage(id, type, message[])
{
message_begin(type, gmsgSayText, _, id);
write_byte(id);
write_string(message);
message_end();
}
*/
#else
ShowColorMessage(id, type, message[])
{
message_begin(type, gmsgSayText, _, id);
write_byte(id);
write_string(message);
message_end();
}
#endif
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1045\\ f0\\ fs16 \n\\ par }
*/
