//Bf2 Rank Mod events File
//Contains all the client command functions

#if defined bf2_events_included
  #endinput
#endif
#define bf2_events_included

//Normal register event functions..
public Event_HLTV()
{
	freezetime = true;
}

public Event_CurWeapon(id)
{
	if ( !is_user_alive(id) || !get_pcvar_num(gPcvarBF2Active) )
		return;

	if ( !get_pcvar_num(gPcvarBadgePowers) )
		return;

	new weapon_id = read_data(2);

	g_invis[id] = false;

	if ( g_lastwpn[id] != weapon_id )
	{
		set_speed(id);
		set_invis(id);
	}

	g_lastwpn[id] = weapon_id;
}

public Event_SetFOV(id)
{
	// Sniper rifle scoping can reset user speed lets fix that

	if ( !get_pcvar_num(gPcvarBF2Active) || !is_user_alive(id) ) return;

	new fov = read_data(1);

	if ( gCurrentFOV[id] != fov ) {
		gCurrentFOV[id] = fov;

		switch(g_lastwpn[id]) {
			// Only need to check speed for sniper rifles
			case  CSW_SCOUT, CSW_SG550, CSW_AWP, CSW_G3SG1: {
				set_speed(id);
			}
		}
	}
}

public Event_DeathMsg()
{
	// csx's client_death does not catch death by world
	// if killer is not a player lets check badges for the victim
	if ( 0 < read_data(1) <= gMaxPlayers ) return;

	check_badges(read_data(2));
}

public setTeam(id)
{
	g_friend[id] = read_data(2);
}

public on_HideStatus(id)
{
	// If miscstats PlayerName option is on do not show this info
	if ( get_xvar_num(gPlayerName) ) return;

	ClearSyncHud(id, gHudSyncAimInfo);
}

public flags_check()
{
	new temp[8];
	get_pcvar_string(gPcvarHudOptions, temp, 7);

	return read_flags(temp);
}

//called when id looks at someone, this needs to be rewritten into one function
public on_ShowStatus(id)
{
	// If miscstats PlayerName option is on do not show this info
	new statsHudMessage = get_xvar_num(gPlayerName);

	new pid = read_data(2);
	new pidrank = g_PlayerRank[pid];
	new flags = flags_check();
	new name[32];
	new color1 = 0, color2 = 0;
	new Float:height;

	get_user_name(pid, name, 31);

	if ( get_user_team(pid) == 1 )
		color1 = 255;
	else
		color2 = 255;

	if (flags & ABOVEHEAD)
		height=0.35;
	else
		height=0.60;

	if ( g_friend[id] == 1 )	// friend
	{
		if ( flags && !statsHudMessage )
		{
			new wpnid = get_user_weapon(pid);
			new wpnname[32];

			if ( wpnid )
				xmod_get_wpnname(wpnid, wpnname, 31);

			set_hudmessage(color1, 50, color2, -1.0, height, 1, 0.01, 3.0, 0.01, 0.01);

			if (flags & TEAMRANK)
			{
				if (flags & STATS)
					ShowSyncHudMsg(id, gHudSyncAimInfo, "%s : %s^n%d HP / %d AP / %s", name, gRankName[pidrank], get_user_health(pid), get_user_armor(pid), wpnname);
				else
					ShowSyncHudMsg(id, gHudSyncAimInfo, "%s : %s", name, gRankName[pidrank]);
			}
			else
			{
				if (flags & STATS)
					ShowSyncHudMsg(id, gHudSyncAimInfo, "%s^n%d HP / %d AP / %s", name, get_user_health(pid), get_user_armor(pid), wpnname);
				else
					ShowSyncHudMsg(id, gHudSyncAimInfo, "%s", name);
			}
		}
		
		/* Wyswietlanie graficznej rangi - 21 spriteow

		new time = floatround(get_pcvar_float(gPcvarIconTime)*10);
		if ( time > 0 )
			Create_TE_PLAYERATTACHMENT(id, pid, 55, gSprite[pidrank], time);
			
		*/
	}
	else if ( flags && !statsHudMessage )
	{
		if (!((flags & HIDEINVIS) && (g_invis[pid])))
		{
			set_hudmessage(color1, 50, color2, -1.0, height, 1, 0.01, 3.0, 0.01, 0.01);

			if (flags & ENEMYRANK)
				ShowSyncHudMsg(id, gHudSyncAimInfo, "%s : %s", name, gRankName[pidrank]);
			else
				ShowSyncHudMsg(id, gHudSyncAimInfo, "%s", name);
		}
	}
}

public Message_Intermission()
{
#if defined SQL
	gIntermission = true;
#endif
	set_task(0.1, "award_check");
}

public Message_StatusValue()
{
	if ( !get_pcvar_num(gPcvarBF2Active) || !get_pcvar_num(gPcvarStatusText) ) return; 

	//Block the name info, of person you aim at
	set_msg_block(gmsgStatusText, BLOCK_SET);
}

//Register logevent functions

public LogEvent_Round_End()
{
	set_task(0.2, "badge_check_loop");
	if(get_cvar_float("amx_timeleft")==0 && rundy > 5 &&  get_cvar_float("mp_timelimit")==0){
		set_task(0.2, "award_check");
	}
}

public LogEvent_Round_Start()
{
	freezetime = false;

	for(new i = 1; i <= gMaxPlayers; i++) {
		set_task(0.1, "set_speed", i);
		set_task(0.1, "set_gravity", i);
		Rheadsplashes[i]=0;
		RzabiciaWdymie[i]=0;
	}
	set_cvar_num("mp_c4timer",45);
	
	++rundy;
	smokenum=-1;
	for(new i=0;i<64;++i){
		for(new j=0;j<5;++j){
			smokepos[i][j]=0;
		}
	}
}

public zerujRundy(){
	rundy=0;
}

/* Obsluga smokow - POCZATEK */
public forward_emitsound(ent, channel, const sound[]) {
    if (!equal(sound, g_sound_explosion) || !is_grenade(ent))
        return FMRES_IGNORED;

    static id, Float:origin[3];
    id = pev(ent, pev_owner);
    pev(ent, pev_origin, origin);
    smokepos[++smokenum][0]=floatround(origin[0]);
    smokepos[smokenum][1]=floatround(origin[1]);
    smokepos[smokenum][2]=floatround(origin[2]);
    smokepos[smokenum][3]=id;
    smokepos[smokenum][4]=get_remaining_seconds();

    return FMRES_IGNORED;
}
bool:is_grenade(ent) {
    if (!pev_valid(ent))
        return false;

    static classname[sizeof g_classname_grenade + 1]
    pev(ent, pev_classname, classname, sizeof g_classname_grenade)
    if (equal(classname, g_classname_grenade))
        return true;

    return false;
}
/* Obsluga smokow - KONIEC */

/* Obsluga flashowania - POCZATEK */
new g_flasher

public SetModel(ent, model[]) 
{    
    if(equal(model, "models/w_flashbang.mdl")) 
    {    
        static owner
        owner = pev(ent, pev_owner)
        if(owner)         
        {
            set_task(1.52,"get_flasher", ID + owner)
        }
    }
} 

public TEMPENTITY()
{    
    set_task(0.05, "reset_flasher") 
    return PLUGIN_CONTINUE
} 

public reset_flasher()
{ 
    g_flasher = 0
}

public get_flasher(id)
{ 
    g_flasher = (id - ID)
}

public ScreenFade(id) 
{    
    if(is_user_alive(id))
    {
        if(id != g_flasher && get_user_team(id) != get_user_team(g_flasher))
        {
            ++flashbangs[g_flasher];
        }
    }    
}
/* Obsluga flashowania - KONIEC */
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1045\\ f0\\ fs16 \n\\ par }
*/
